SystemOrganization addCategory: #'Pier-Book'!

!PRStructure methodsFor: '*pier-book' stamp: 'lr 4/24/2009 11:56'!
isPublication
	^ false! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:11'!
visitIndexLink: aLink
	self visitLink: aLink! !

!PRLinkRenderer methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:35'!
visitIndexLink: aLink
	html anchor name: aLink title.
	parent visitAll: aLink children! !

PRLink subclass: #BOIndexLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:08'!
isAbstract
	^ false! !

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:09'!
isValidReference: aString
	^ aString beginsWith: 'index:'! !

!BOIndexLink methodsFor: 'visiting' stamp: 'lr 5/1/2009 22:09'!
accept: aVisitor
	aVisitor visitIndexLink: self! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/1/2009 22:13'!
title
	^ super title copyAfter: $:! !

PRCase subclass: #BOBook
	instanceVariableNames: 'subtitle tagline authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:38'!
descriptionAuthors
	^ MAStringDescription new
		parameterName: 'authors';
		accessor: #authors;
		label: 'Authors';
		beSearchable;
		priority: 400;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 11:54'!
descriptionNumber
	^ nil! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionSubtitle
	^ MAStringDescription new
		parameterName: 'subtitle';
		accessor: #subtitle;
		label: 'Subtitle';
		beSearchable;
		priority: 200;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionTagline
	^ MAStringDescription new
		parameterName: 'tagline';
		accessor: #tagline;
		label: 'Tagline';
		beSearchable;
		priority: 300;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:31'!
label
	^ 'Book'! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors
	^ authors! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors: anObject
	authors := anObject! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle
	^ subtitle! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle: aString
	subtitle := aString! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline
	^ tagline! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline: aString
	tagline := aString! !

PRCase subclass: #BOPublication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

BOPublication subclass: #BOChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOChapter class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOBook! !

!BOChapter class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:21'!
label
	^ 'Chapter'! !

!BOChapter methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isChapter
	^ true! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 12:20'!
descriptionNumber
	^ MAStringDescription new
		parameterName: 'number';
		accessor: #number;
		beReadonly;
		yourself! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:21'!
isAbstract
	^ self name = #POPublication! !

!BOPublication methodsFor: 'comparing' stamp: 'lr 4/24/2009 12:10'!
< aStructure
	| siblings |
	(self parent isNil or: [ self parent ~= aStructure parent ])
		ifTrue: [ ^ super < aStructure ].
	(aStructure isPublication)
		ifFalse: [ ^ false ].
	siblings := self parent childrenDecoration children.
	^ (siblings indexOf: self) < (siblings indexOf: aStructure)
		! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 4/24/2009 11:45'!
index
	"Answer the index number of this publication, for example the chapter or section number."
	
	| siblings |
	self parent isNil
		ifTrue: [ ^ 0 ].
	siblings := self parent childrenDecoration children
		select: [ :each | each isKindOf: self class ].
	^ siblings indexOf: self ifAbsent: [ 0 ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:40'!
isChapter
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/23/2009 19:32'!
isPublication
	^ true! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ false! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 4/24/2009 12:05'!
number
	"Answer the composed numbers."

	| publications index |
	publications := self parents
		select: [ :each | each isPublication ].
	index := publications
		findLast: [ :each | each isChapter ].
	publications isZero
		ifTrue: [ ^ nil ].
	^ ((publications copyFrom: index to: publications size)	
		collect: [ :each | each index asString ])
		reduce: [ :a :b | a , '.' , b ]! !

BOPublication subclass: #BOSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOSection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOChapter! !

!BOSection class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:22'!
label
	^ 'Section'! !

!BOSection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ true! !

BOPublication subclass: #BOSubsection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book'!

!BOSubsection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:33'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOSection! !

!BOSubsection class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:22'!
label
	^ 'Subsection'! !

!BOSubsection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ true! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:36'!
indexIn: aContext
	<value: 'index' comment: 'Display an index of keywords.'>

	^ self lookupStructure: aContext structure do: [ :root |
		| index |
		index := Dictionary new.
		root enumerator everything do: [ :struct |
			struct outgoingReferences do: [ :refer |
				(refer isKindOf: BOIndexLink) ifTrue: [ 
					(index at: refer title ifAbsentPut: [ OrderedCollection new ])
						addLast: refer owner ] ] ].
		(index keys asSortedCollection: [ :a :b | a asLowercase < b asLowercase ])
			inject: PRDefinitionList new
			into: [ :list :word |
				list add: (PRTermItem with: (PRText content: word)).
				(index at: word) do: [ :struct |
					list add: (PRDataItem with: (PRInternalLink new
						anchor: word;
						target: struct;
						yourself)) ].
				list ] ]! !
